package salaComunitaria.controllers;

import java.util.Date;
import java.util.List;

import javax.json.Json;
import javax.json.JsonObject;

import jakarta.inject.Inject;
import jakarta.ws.rs.Consumes;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.core.Context;
import jakarta.ws.rs.core.MediaType;
import jakarta.ws.rs.core.Request;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.core.UriInfo;
import salaComunitaria.DTO.LoginDTO;
import salaComunitaria.entities.User;
import salaComunitaria.interfacesDAO.UserDAO;

import io.jsonwebtoken.Jwts;
import io.jsonwebtoken.SignatureAlgorithm;
import io.jsonwebtoken.security.Keys;

@Path("/login")
public class LoginController {
	
	@Context
	UriInfo uriInfo;

	@Context
	Request request;
	
	@Inject
	private UserDAO udao;
	
	@POST
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_JSON)
	public Response login(LoginDTO usuario) {
		
		List<User> users = udao.get();
		JsonObject json = null;
		
		String secret = "asdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasd";
		
		User user = users.stream()
				.filter( u -> u.getEmail().equals(usuario.getEmail()) && u.getPassword().equals(usuario.getPassword()))
				.findAny()
				.orElse(null);
		
		if(user == null) {
			String message = "mail o password incorrectos";
			return Response.status(Response.Status.NOT_FOUND).entity(message).build();
		}else {
			String jwt = Jwts.builder()
					.signWith(SignatureAlgorithm.HS256, Keys.hmacShaKeyFor(secret.getBytes()))
					.setSubject("test")
					.setIssuedAt(new Date(System.currentTimeMillis()))
					.claim("mail", user.getEmail())
					.claim("id", user.getId())
					.claim("role", user.getRole())
					.compact();
		
			json = Json.createObjectBuilder().add("JWT", jwt).build();
		}
		
		return Response.ok().entity(json).build();
	}

}
