package salaComunitaria.entities;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;

@Entity
public class InventoryEvent extends Event {
	
	@OneToOne
	@JoinColumn(name="RAW_MATERIAL_ID")
	private RawMaterial rawMaterial;
	
	@OneToOne
    @JoinColumn(name = "INPUT_ID")
    private Input input;
	
	private int quantity;
	
	@Column(name = "Type")
    private String typeEvent; // "IN" for ingress, "OUT" for egress, "Modify" for modification
    
	public InventoryEvent() {
		super();
	}

	public RawMaterial getRawMaterial() {
		return rawMaterial;
	}

	public void setRawMaterial(RawMaterial rawMaterial) {
		if (input!= null) {
            this.input = null;
        }
        this.rawMaterial = rawMaterial;
	}

	public Input getInput() {
		return input;
	}

	public void setInput(Input input) {
		if (rawMaterial!= null) {
            this.rawMaterial = null;
        }
        this.input = input;
	}

	public int getQuantity() {
		return quantity;
	}

	public void setQuantity(int quantity) {
		this.quantity = quantity;
	}

	public String getTypeEvent() {
		return typeEvent;
	}

	public void setTypeEvent(String typeEvent) {
		this.typeEvent = typeEvent;
	}
    
    
    
}
