package salaComunitaria.entities;

import javax.persistence.*;

import org.hibernate.annotations.ResultCheckStyle;
import org.hibernate.annotations.SQLDelete;
import org.hibernate.annotations.Where;


@Entity
@SQLDelete(sql = "UPDATE RECIPES SET state = 'DELETED' WHERE RECIPE_ID = ?", check = ResultCheckStyle.COUNT)
@Where(clause = "state <> 'DELETED'")
@NamedQuery(name = "recipies.FindById", query = "SELECT a FROM Recipe a WHERE a.id = :id")
@Table(name="RECIPES")
public class Recipe {
	

	//Attributes
	@Id @GeneratedValue
	@Column(name="RECIPE_ID")
	private long id;
	
	@Column(nullable=false)
	private String name;
	
	@Column(nullable=false)
	private String description;
	
	//Los estados que se van a manejar son ACTIVE y DELETED
    @Column(nullable=false, name="state")
    private String state = "ACTIVE";
	
	//Relations
	@Column(nullable=false)
	private String recipeIngredients;
	
	
	@Column(nullable=false)
	private String recipePackagingElements;
	
	public Recipe() {
		super();
	}

	//Getters and Setters
	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getState() {
		return state;
	}

	public void setState(String state) {
		this.state = state;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getRecipeIngredients() {
		return recipeIngredients;
	}

	public void setRecipeIngredients(String recipeIngredients) {
		this.recipeIngredients = recipeIngredients;
	}

	public String getRecipePackagingElements() {
		return recipePackagingElements;
	}

	public void setRecipePackagingElements(String recipePackagingElements) {
		this.recipePackagingElements = recipePackagingElements;
	}

	@Override
	public String toString() {
		return "Recipe [id=" + id + ", name=" + name + ", description=" + description + ", recipeIngredients="
				+ recipeIngredients + ", recipePackagingElements=" + recipePackagingElements + "]";
	}

	
}
