package salaComunitaria.entities;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;

import com.fasterxml.jackson.annotation.JsonProperty;

@Entity
public class SaleEvent extends Event {

    @ManyToMany
    @JoinTable(name="SOLD_BATCHES",
               joinColumns=@JoinColumn(name="EVENT_ID"),
               inverseJoinColumns=@JoinColumn(name="BATCH_ID"))
    private Set<Batch> soldBatches;

    @ManyToOne
    @JsonProperty("saleChannel")
    @JoinColumn(name="SALE_CHANNEL_ID")  
    private SalesChannel saleChannel;

    @Column(nullable=false)
    private String quantities;

    @Column(nullable=false)
    private String unitsPrice;

    @Column(nullable=false)
    private double cost;


	public SaleEvent() {
		super();
	}

	public Set<Batch> getSoldBatches() {
		return soldBatches;
	}

	public void setSoldBatches(Set<Batch> soldBatches) {
		this.soldBatches = soldBatches;
	}

	
	public SalesChannel getSaleChannel() {
		return saleChannel;
	}

	public void setSaleChannel(SalesChannel saleChannel) {
		this.saleChannel = saleChannel;
	}

	public String getUnitsPrice() {
		return unitsPrice;
	}

	public void setUnitsPrice(String unitsPrice) {
		this.unitsPrice = unitsPrice;
	}

	public String getQuantities() {
		return quantities;
	}

	public void setQuantities(String quantities) {
		this.quantities = quantities;
	}


	public double getCost() {
		return cost;
	}

	public void setCost(double cost) {
		this.cost = cost;
	}
	
}
