package salaComunitaria.entities;

import java.util.Set;

import javax.persistence.*;

import org.hibernate.annotations.ResultCheckStyle;
import org.hibernate.annotations.SQLDelete;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@SQLDelete(sql = "UPDATE SALESCHANNELS SET state = 'DELETED' WHERE SALESCHANNEL_ID = ?", check = ResultCheckStyle.COUNT)
@Where(clause = "state <> 'DELETED'")
@NamedQuery(name = "saleschannels.FindById", query = "SELECT a FROM SalesChannel a WHERE a.id = :id")
@Table(name="SALESCHANNELS")
public class SalesChannel {
	

	//Attributes
	@Id @GeneratedValue
	@Column(name="SALESCHANNEL_ID")
	private long id;
	
	@Column(nullable=false)
	private String name;
	
	@Column(nullable=false)
	private String addres;
	
	@Column(nullable=false)
	private String cuit;
	
	@Column(nullable=false)
	private String phone;
	
	@Column(nullable=false)
	private String email;
	
	//Los estados que se van a manejar son ACTIVE y DELETED
    @Column(nullable=false, name="state")
    private String state = "ACTIVE";

	//Relations
	@JsonIgnore
	@OneToMany(mappedBy = "saleChannel")
	private Set<SaleEvent> saleEvents;
	
	public SalesChannel() {
		super();
	}

	//Getters and Setters
	
	public long getId() {
		return id;
	}
	
	public void setId(long id) {
		this.id = id;
	}

	public String getState() {
		return state;
	}

	public void setState(String state) {
		this.state = state;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getAddres() {
		return addres;
	}

	public void setAddres(String addres) {
		this.addres = addres;
	}

	public String getCuit() {
		return cuit;
	}

	public void setCuit(String cuit) {
		this.cuit = cuit;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}
	
	public Set<SaleEvent> getSaleEvents() {
		return saleEvents;
	}

	public void setSaleEvents(Set<SaleEvent> saleEvents) {
		this.saleEvents = saleEvents;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}
	
	

	@Override
	public String toString() {
		return "SalesChannel [id=" + id + ", name=" + name + ", addres=" + addres + ", cuit=" + cuit + ", phone="
				+ phone + "]";
	}	

	
}
