package salaComunitaria.objectsDAO;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.jvnet.hk2.annotations.Service;

import salaComunitaria.entities.Batch;
import salaComunitaria.entities.Input;
import salaComunitaria.entities.RawMaterial;
import salaComunitaria.interfacesDAO.BatchDAO;

@Service 
public class BatchDAOImpl extends GenericDAOImpl<Batch> implements BatchDAO{
	
	private EntityManagerFactory entityManagerFactory;

    public void saveBatch(Batch batch) {
    	entityManagerFactory = Persistence.createEntityManagerFactory("miUP");
        EntityManager em = entityManagerFactory.createEntityManager();
        EntityTransaction tx = em.getTransaction();

        try {
            tx.begin();

            if(!(batch.getBatchIngredients() == null)) {
                Set<RawMaterial> managedIngredients = new HashSet<>();
                for (RawMaterial ingredient : batch.getBatchIngredients()) {
                    RawMaterial managedIngredient = em.find(RawMaterial.class, ingredient.getId());
                    managedIngredients.add(managedIngredient);
                }
                batch.setBatchIngredients(managedIngredients);
            }

            if(!(batch.getBatchPackagingElements() == null)) {
                Set<Input> managedInputs = new HashSet<>();
                for (Input input : batch.getBatchPackagingElements()) {
                    Input managedInput = em.find(Input.class, input.getId());
                    managedInputs.add(managedInput);
                }
                batch.setBatchPackagingElements(managedInputs);
            }

            em.merge(batch); 
            tx.commit();
        } catch (Exception e) {
            if (tx.isActive()) {
                tx.rollback();
            }
            e.printStackTrace();
        } finally {
            em.close();
        }
    }

}
