package salaComunitaria.objectsDAO;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.jvnet.hk2.annotations.Service;

import salaComunitaria.entities.Batch;
import salaComunitaria.entities.Input;
import salaComunitaria.entities.Provider;
import salaComunitaria.interfacesDAO.InputDAO;

@Service 
public class InputDAOImpl extends GenericDAOImpl<Input> implements InputDAO{
	
	private EntityManagerFactory entityManagerFactory;

    public void saveInput(Input input) {
    	entityManagerFactory = Persistence.createEntityManagerFactory("miUP");
        EntityManager em = entityManagerFactory.createEntityManager();
        EntityTransaction tx = em.getTransaction();

        try {
            tx.begin();
            
            if (input.getProvider() != null) {
                Provider managedProvider = em.find(Provider.class, input.getProvider().getId());
                input.setProvider(managedProvider);
            }

            Set<Batch> managedBatches = new HashSet<Batch>();
            if (input.getBatches() != null) {
                for (Batch batch : input.getBatches()) {
                    Batch managedBatch = em.find(Batch.class, batch.getId());
                    Set<Input> inputs = new HashSet<Input>();
                    if (managedBatch != null) {
                    	inputs.add(input);
                        managedBatch.setBatchPackagingElements(inputs); 
                        managedBatches.add(managedBatch);
                    }
                }
            }
            input.setBatches(managedBatches);

            em.merge(input);
            tx.commit();
        } catch (Exception e) {
            if (tx.isActive()) {
                tx.rollback();
            }
            e.printStackTrace();
        } finally {
            em.close();
        }
    }

}
