package salaComunitaria.objectsDAO;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.jvnet.hk2.annotations.Service;

import salaComunitaria.entities.Input;
import salaComunitaria.entities.Provider;
import salaComunitaria.entities.RawMaterial;
import salaComunitaria.interfacesDAO.ProviderDAO;

@Service 
public class ProviderDAOImpl extends GenericDAOImpl<Provider> implements ProviderDAO{
	
    private EntityManagerFactory entityManagerFactory;

    public void saveProvider(Provider provider) {
    	entityManagerFactory = Persistence.createEntityManagerFactory("miUP");
        EntityManager em = entityManagerFactory.createEntityManager();
        EntityTransaction tx = em.getTransaction();

        try {
            tx.begin();

            if(!(provider.getRawMaterials() == null)) {
                Set<RawMaterial> managedRawMaterials = new HashSet<>();
                for (RawMaterial rawMaterial : provider.getRawMaterials()) {
                    RawMaterial managedRawMaterial = em.find(RawMaterial.class, rawMaterial.getId());
                    if (managedRawMaterial == null) {
                        managedRawMaterial = rawMaterial;
                    }
                    managedRawMaterials.add(managedRawMaterial);
                }
                provider.setRawMaterials(managedRawMaterials);
            }

            if(!(provider.getInputs() == null)) {
                Set<Input> managedInputs = new HashSet<>();
                for (Input input : provider.getInputs()) {
                    Input managedInput = em.find(Input.class, input.getId());
                    if (managedInput == null) {
                        managedInput = input;
                    }
                    managedInputs.add(managedInput);
                }
                provider.setInputs(managedInputs);
            }

            em.merge(provider);
            tx.commit();
        } catch (Exception e) {
            if (tx.isActive()) {
                tx.rollback();
            }
            e.printStackTrace();
        } finally {
            em.close();
        }
    }

}
