package salaComunitaria.objectsDAO;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.jvnet.hk2.annotations.Service;

import salaComunitaria.entities.Batch;
import salaComunitaria.entities.Provider;
import salaComunitaria.entities.RawMaterial;
import salaComunitaria.interfacesDAO.RawMaterialDAO;

@Service 
public class RawMaterialImpl extends GenericDAOImpl<RawMaterial> implements RawMaterialDAO{
    private EntityManagerFactory entityManagerFactory;

    public void saveRawMaterial(RawMaterial rawMaterial) {
    	entityManagerFactory = Persistence.createEntityManagerFactory("miUP");
        EntityManager em = entityManagerFactory.createEntityManager();
        EntityTransaction tx = em.getTransaction();

        try {
            tx.begin();

            if (rawMaterial.getProvider() != null) {
                Provider managedProvider = em.find(Provider.class, rawMaterial.getProvider().getId());
                rawMaterial.setProvider(managedProvider);
            }

            if(!(rawMaterial.getBatches()==null)) {
                Set<Batch> managedBatches = new HashSet<>();
                for (Batch batch : rawMaterial.getBatches()) {
                    Batch managedBatch = em.find(Batch.class, batch.getId());
                    if (managedBatch == null) {
                        managedBatch = batch;
                    }
                    managedBatches.add(managedBatch);
                }
                rawMaterial.setBatches(managedBatches);
            }

            em.merge(rawMaterial);
            tx.commit();
        } catch (Exception e) {
            if (tx.isActive()) {
                tx.rollback();
            }
            e.printStackTrace();
        } finally {
            em.close();
        }
    }
}
