package salaComunitaria.servlets;

import jakarta.inject.Inject;
import jakarta.servlet.Filter;
import jakarta.servlet.FilterChain;
import jakarta.servlet.FilterConfig;
import jakarta.servlet.ServletException;
import jakarta.servlet.ServletRequest;
import jakarta.servlet.ServletResponse;
import jakarta.servlet.annotation.WebFilter;
import jakarta.servlet.http.HttpFilter;
import jakarta.servlet.http.HttpServletRequest;
import salaComunitaria.entities.User;
import salaComunitaria.interfacesDAO.UserDAO;
import salaComunitaria.objectsDAO.UserDAOImpl;

import java.io.IOException;

import io.jsonwebtoken.Claims;
import io.jsonwebtoken.Jwts;
import io.jsonwebtoken.security.Keys;

/**
 * Servlet Filter implementation class FilterJWT
 */
public class FilterJWT extends HttpFilter implements Filter {

	private UserDAO udao = new UserDAOImpl();

	public FilterJWT() {
		super();
	}

	public void destroy() {

	}

	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)
			throws IOException, ServletException {

		HttpServletRequest httpReq = (HttpServletRequest) request;

		String path = httpReq.getRequestURI();

		String token;

		if (!path.equals("/SalaComunitaria/api/login")) {

			try {
				token = httpReq.getHeader("Authorization").substring(6);

				if (token == null) {
					request.setAttribute("token", "fail");
				} else {
					request.setAttribute("token", "ok");
				}

				String secret = "asdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasdasd";

				Claims claims = Jwts.parser().setSigningKey(Keys.hmacShaKeyFor(secret.getBytes())).parseClaimsJws(token)
						.getBody();

				String subject = claims.getSubject();
				String email = claims.get("mail", String.class);
				int id = claims.get("id", Integer.class);
				String role = claims.get("role", String.class);

				User user = udao.get(id);

				if (user == null) {
					request.setAttribute("token", "fail");
				} else {
					request.setAttribute("token", "ok");
				}

			} catch (Exception e) {
				request.setAttribute("token", "fail");
			}

		}

		chain.doFilter(request, response);
	}

	/**
	 * @see Filter#init(FilterConfig)
	 */
	public void init(FilterConfig fConfig) throws ServletException {
		// TODO Auto-generated method stub
	}

}
