package salaComunitaria.utils;

import javax.persistence.EntityManager;

import org.glassfish.hk2.utilities.binding.AbstractBinder;
import org.glassfish.jersey.process.internal.RequestScope;
import org.glassfish.jersey.process.internal.RequestScoped;

import jakarta.inject.Singleton;
import salaComunitaria.interfacesDAO.BatchDAO;
import salaComunitaria.interfacesDAO.EventDAO;
import salaComunitaria.interfacesDAO.InputDAO;
import salaComunitaria.interfacesDAO.ProviderDAO;
import salaComunitaria.interfacesDAO.RawMaterialDAO;
import salaComunitaria.interfacesDAO.RecipeDAO;
import salaComunitaria.interfacesDAO.SalesChannelDAO;
import salaComunitaria.interfacesDAO.UserDAO;
import salaComunitaria.objectsDAO.BatchDAOImpl;
import salaComunitaria.objectsDAO.EventDAOImpl;
import salaComunitaria.objectsDAO.InputDAOImpl;
import salaComunitaria.objectsDAO.ProviderDAOImpl;
import salaComunitaria.objectsDAO.RawMaterialImpl;
import salaComunitaria.objectsDAO.RecipeDAOImpl;
import salaComunitaria.objectsDAO.SalesChannelDAOImpl;
import salaComunitaria.objectsDAO.UserDAOImpl;


public class MyApplicationBinder extends AbstractBinder {
	  
	
	@Override
    protected void configure() {
    		    	
		bind(UserDAOImpl.class).to(UserDAO.class);
		bind(BatchDAOImpl.class).to(BatchDAO.class);
		bind(EventDAOImpl.class).to(EventDAO.class);
		bind(InputDAOImpl.class).to(InputDAO.class);
		bind(ProviderDAOImpl.class).to(ProviderDAO.class);
		bind(RawMaterialImpl.class).to(RawMaterialDAO.class);
		bind(RecipeDAOImpl.class).to(RecipeDAO.class);
		bind(SalesChannelDAOImpl.class).to(SalesChannelDAO.class);
		bindFactory(EntityManagerFactoryProvider.class).to(EntityManager.class).in(RequestScoped.class);
    	
    }	

}
